'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'                                PATHFINDER                                 '
'                                                                           '
'            An unrefined translation from PASCAL to QBASIC of              '
'            John Christian Lonningdal's 03btpath.pas program.              '
'            Check out http://home.sol.no/~johncl/shorpath.htm              '
'            Mouse Routine written by Dan Campbell.                         '
'                                                                           '
'            * Note:                                                        '
'            Requires qb.qlb quick basic libary.                            '
'            (Start QBasic with the /L command line)                        '
'                                                                           '
'                              translation by                               '
'                      John Paul Jones, 30th Sept 2000                      '
'                     http://gofree.indigo.ie/~jonesjp/                     '
'                                                                           '
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

DEFINT A-Z
'$DYNAMIC

'Mouse Subs:

DECLARE SUB ReadData ()
DECLARE SUB InitMouse ()
DECLARE SUB getmouse (mode)
DECLARE SUB mouse (OnOff)
DECLARE FUNCTION Interupt (Num, ax, bx, cx, Dx)

'Map Subs:

DECLARE SUB NewMap ()
DECLARE SUB LoadMap ()
DECLARE SUB SaveMap ()
DECLARE SUB editmap ()
DECLARE SUB DrawMap ()

'Pathfind Subs:

DECLARE SUB NewAngle ()
DECLARE SUB Pathfind ()
DECLARE SUB BackTrack ()
DECLARE SUB LineIntersect ()

'============================================================================


'Mouse Variables:

DIM SHARED Xcoord, Ycoord, click
DIM SHARED ml(45)
DIM SHARED e

'Map Variables:

DIM SHARED map(10, 10)                  'Map Array
DIM SHARED xsize, ysize                 'Map dimensions
DIM SHARED xsta, ysta                   'Start
DIM SHARED xdes, ydes                   'Destination
DIM SHARED os                           'OffSet from top left
DIM SHARED g                            'Grid Size

'Pathfind Variables:

TYPE mapcoord
x AS INTEGER
y AS INTEGER
END TYPE

DIM SHARED diffx, diffy                 'Distance from start to destination
DIM SHARED stepcnt                      'Step count
DIM SHARED shortest                     'Shortest step
DIM SHARED angle                        '0-7, north,east,south,west etc.
DIM SHARED PCnt                         '# of paths in count
DIM SHARED lenmap(10, 10)               'Array containing map distances
DIM SHARED plist(500) AS mapcoord       'Open list of paths
DIM SHARED llist(500)                   'Open list of path-lengths
DIM SHARED npos AS mapcoord             'NewPosition
DIM SHARED cpos AS mapcoord             'CurrentPosition
DIM SHARED Goalreached                  'Boolean
DIM SHARED wide                         'Boolean

wide = 1                                'wide search mode

'BackTrack Variables:

DIM SHARED shstep                       'Shortest Step
DIM SHARED count                        '# of moves
DIM SHARED spos AS mapcoord             'Shortest Position

'LineIntersect Variables:

DIM SHARED x!, y!                       'origin
DIM SHARED sx!, sy!                     'amount to move origin    
DIM SHARED Dx!, Dy!                     'distance from origin to current position
DIM SHARED li                           'LineIntersect (Boolean)
DIM SHARED dr                           'DrawLine      (Boolean)
DIM SHARED i                            'incrementer
DIM SHARED steps                        'incrementer
DIM SHARED lspos AS mapcoord            'Line Start position
DIM SHARED bestline AS mapcoord
			
'Misc Variables

DIM SHARED n, m, i$                     'Loop Increments & key input

'============================================================================


'Initialise
ON KEY(1) GOSUB Help

CLS
SCREEN 12

ReadData
InitMouse
getmouse mode
mouse 0
MS.Data:
 DATA 55,8b,ec,56,57
 DATA 8b,76,0c,8b,04
 DATA 8b,76,0a,8b,1c
 DATA 8b,76,08,8b,0c
 DATA 8b,76,06,8b,14
 DATA cd,21       
 DATA 8b,76,0c,89,04
 DATA 8b,76,0a,89,1c
 DATA 8b,76,08,89,0c
 DATA 8b,76,06,89,14
 DATA 5f,5e,5d     
 DATA ca,08,00     
 DATA #

'============================================================================


start:
CLS
INPUT "New Map (Y/N) "; i$
i$ = UCASE$(i$)
IF i$ = "Y" THEN CALL NewMap ELSE CALL LoadMap

repeat:
CALL DrawMap
 CALL editmap
  CALL SaveMap
   CALL Pathfind
    IF Goalreached = 0 THEN CALL LoadMap: GOTO repeat
     CALL BackTrack
      CALL LoadMap
GOTO repeat

'============================================================================

Help:
mouse 0
KEY(1) OFF
CLS
LOCATE 1, 1
PRINT "                                  PATHFINDER "
PRINT "                                 ------------"
PRINT : COLOR 7
PRINT "Use the "; : COLOR 15
PRINT "left & right mouse buttons"; : COLOR 7
PRINT " to draw/delete blocks."
PRINT "Holding down "; : COLOR 9
PRINT "A"; : COLOR 7
PRINT " or "; : COLOR 4
PRINT "B"; : COLOR 7
PRINT " while dragging the mouse will move the start/finish points."
PRINT "Press"; : COLOR 15
PRINT " space"; : COLOR 7
PRINT " to calculate the path.": PRINT
PRINT "Pressing"; : COLOR 15
PRINT " Escape"; : COLOR 7
PRINT " at any time quits."
COLOR 15: LOCATE 30, 1
PRINT "Press any key to continue...";

helploop:
i$ = INKEY$: IF i$ = "" THEN GOTO helploop
IF i$ = CHR$(27) THEN END
CALL DrawMap
LOCATE 30, 1
PRINT "F1 - Help.                                                         ESC - exit.";
KEY(1) ON
i$ = ""
RETURN

'============================================================================

SUB BackTrack
'Backtrack from B to A , choose the shortest path at every step

count = 1
cpos.x = xdes
cpos.y = ydes
spos = npos
count = 0
lspos = cpos

WHILE NOT (cpos.x = xsta AND cpos.y = ysta)

'count = count + 1
shstep = 32767
npos = cpos
angle = 0
npos.y = npos.y - 1

FOR n = 0 TO 7
npos = cpos
CALL NewAngle
IF lenmap(npos.x, npos.y) < shstep THEN
 shstep = lenmap(npos.x, npos.y)
  spos = npos
   END IF
NEXT
cpos = spos

'this line is the unrefined back-track:
'LINE ((cpos.x * g) - g + 2, (cpos.y * g) - g + 2)-((cpos.x * g) - 2, (cpos.y * g) - 2), 7, BF

'line-intersect routine:

dr = 0                                  'Dont draw the path yet, just check for obstruction
CALL LineIntersect
IF li = 0 THEN bestline = cpos

IF (cpos.x = xsta AND cpos.y = ysta) THEN
cpos = bestline
dr = 1                                  'Draw the path
CALL LineIntersect
count = count + steps
LINE ((cpos.x * g) - g + 1, (cpos.y * g) - g + 1)-((cpos.x * g) - 1, (cpos.y * g) - 1), 14, BF
LINE ((lspos.x * g) - (g / 2), (lspos.y * g) - (g / 2))-((cpos.x * g) - (g / 2), (cpos.y * g) - (g / 2)), 15
lspos = cpos
END IF
WEND

'Place Start Point again (Doh!)
D = g - 1
LINE ((xsta * g) + os - D, (ysta * g) + os - D)-((xsta * g) + os - 1, (ysta * g) + os - 1), 9, BF



EndTrack:
LOCATE 30, 1: PRINT "Path found in"; count; "Moves.";
i$ = INKEY$
IF i$ = "" THEN GOTO EndTrack
IF i$ = CHR$(27) THEN END
END SUB

SUB DrawMap
CLS
D = g - 1

'draw map-grid:
 FOR n = 0 TO xsize
 LINE ((n * g) + os, os)-((n * g) + os, (ysize * g) + os), 1
 NEXT
 FOR m = 0 TO ysize
 LINE (os, (m * g) + os)-((xsize * g) + os, (m * g) + os), 1
 NEXT

'fill in walls:
 FOR n = 1 TO xsize
 FOR m = 1 TO ysize
 IF map(n, m) = 0 THEN LINE (((n * g) - D) + os, ((m * g) - D) + os)-(((n * g) - 1) + os, ((m * g) - 1) + os), 2, BF
 IF map(n, m) > 1 THEN LINE (((n * g) - D) + os, ((m * g) - D) + os)-(((n * g) - 1) + os, ((m * g) - 1) + os), 7, BF
 NEXT m, n

'Place Start/Destination Points
 D = g - 1
 LINE ((xdes * g) + os - D, (ydes * g) + os - D)-((xdes * g) + os - 1, (ydes * g) + os - 1), 4, BF
 LINE ((xsta * g) + os - D, (ysta * g) + os - D)-((xsta * g) + os - 1, (ysta * g) + os - 1), 9, BF

END SUB

SUB editmap
KEY(1) ON
e = (g / 2)
'Offset variable to correct mouse position with regard to gridsize
LOCATE 30, 1
PRINT "F1 - Help.                                                         ESC - exit.";

editloop:

DO
i$ = INKEY$
IF i$ = CHR$(27) THEN END
IF i$ = CHR$(32) THEN GOTO endedit
IF UCASE$(i$) = "W" THEN
LOCATE 30, 30
IF wide = 1 THEN
PRINT "Narrow Search";
wide = 0
ELSE
PRINT "Wide Search  ";
wide = 1
END IF
END IF

getmouse 0
mouse 1
n = ((Xcoord + e) - os) / g
m = ((Ycoord + e) - os) / g
IF n < 1 OR m < 1 OR n > xsize OR m > ysize THEN GOTO editloop
IF click <> 0 THEN GOTO fill

LOOP WHILE i$ = ""
mouse 0
IF UCASE$(i$) = "A" AND map(n, m) <> 0 THEN
SWAP xsta, n
SWAP ysta, m
GOTO show
END IF

IF UCASE$(i$) = "B" AND map(n, m) <> 0 THEN
SWAP xdes, n
SWAP ydes, m
GOTO show
END IF

GOTO editloop

fill:
IF (n = xdes AND m = ydes) OR (n = xsta AND m = ysta) THEN GOTO editloop
mouse 0
D = g - 1
IF click = 1 THEN
map(n, m) = 0
LINE (((n * g) - D) + os, ((m * g) - D) + os)-(((n * g) - 1) + os, ((m * g) - 1) + os), 2, BF
END IF
IF click = 2 THEN
map(n, m) = 1
LINE (((n * g) - D) + os, ((m * g) - D) + os)-(((n * g) - 1) + os, ((m * g) - 1) + os), 0, BF
END IF
GOTO editloop

'Show Start/Destination Points
show:
 D = g - 1
 IF map(n, m) = 1 THEN col = 0 ELSE col = 2
 LINE (((n * g) - D) + os, ((m * g) - D) + os)-(((n * g) - 1) + os, ((m * g) - 1) + os), col, BF
 LINE ((xdes * g) + os - D, (ydes * g) + os - D)-((xdes * g) + os - 1, (ydes * g) + os - 1), 4, BF
 LINE ((xsta * g) + os - D, (ysta * g) + os - D)-((xsta * g) + os - 1, (ysta * g) + os - 1), 9, BF
GOTO editloop
endedit:
mouse 0
KEY(1) OFF
END SUB

SUB getmouse (mode)

  r = Interupt(&H33, 3, bx, cx, Dx)

  click = bx

  IF mode THEN
   Xcoord = cx / 16 + 1
   Ycoord = Dx / 16 + 1
  ELSE
   Xcoord = cx
   Ycoord = Dx
  END IF


END SUB

SUB InitMouse

'Calls mouse interrupts...

 r = Interupt(&H33, 0, bx, cx, Dx)

END SUB

FUNCTION Interupt (Num, ax, bx, cx, Dx)

 IF ml(0) = 0 THEN   'Error, no MS.Data statment...
 BEEP
 BEEP
 END
 END IF

 DEF SEG = VARSEG(ml(0))
 POKE VARPTR(ml(0)) + 26, Num

 CALL ABSOLUTE(ax, bx, cx, Dx, VARPTR(ml(0)))

 Interupt = ax


END FUNCTION

SUB LineIntersect
steps = 0
li = 0
x! = lspos.x
y! = lspos.y

liloop:
Dx! = x! - cpos.x
Dy! = y! - cpos.y

IF (ABS(Dx!) > ABS(Dy!)) THEN
IF Dx! > 0 THEN sx! = -1 ELSE sx! = 1
IF Dx! = 0 THEN sy! = 0 ELSE sy! = Dy! / (Dx! * sx!)
steps = ABS(Dx!)
ELSE
IF Dy! > 0 THEN sy! = -1 ELSE sy! = 1
IF Dy! = 0 THEN sx! = 0 ELSE sx! = Dx! / (Dy! * sy!)
steps = ABS(Dy!)
END IF

FOR i = 0 TO steps
IF (map(CINT(x!), CINT(y!)) <> 1) THEN li = 1
IF (dr = 1 AND i > 0) THEN
'count = count + 1
LINE ((CINT(x!) * g) - g + 1, (CINT(y!) * g) - g + 1)-((CINT(x!) * g) - 1, (CINT(y!) * g) - 1), 6, BF
END IF

x! = x! + sx!
y! = y! + sy!

NEXT
'IF steps > 0 THEN GOTO liloop

END SUB

SUB LoadMap
CLS

OPEN "pathfind.dat" FOR INPUT AS #1

 INPUT #1, g, xsize, ysize
 REDIM map(xsize, ysize)
  FOR n = 1 TO xsize
  FOR m = 1 TO ysize
   INPUT #1, map(n, m)
  NEXT: NEXT
 INPUT #1, xsta, ysta, xdes, ydes

CLOSE #1
END SUB

SUB mouse (OnOff)

 IF OnOff = 0 THEN OnOff = 2 ELSE OnOff = 1
 r = Interupt(&H33, OnOff, bx, cx, Dx)

END SUB

SUB NewAngle
'Star-shaped search pattern:
'Scan n,e,s,w,nw,ne,sw,se
'(angles 0-7 clockwise)
'and update new position

SELECT CASE angle

	CASE 0: npos.y = npos.y - 1:                            angle = 2
	CASE 1: npos.x = npos.x + 1: npos.y = npos.y - 1:       angle = 3
	CASE 2: npos.x = npos.x + 1:                            angle = 4
	CASE 3: npos.x = npos.x + 1: npos.y = npos.y + 1:       angle = 5
	CASE 4: npos.y = npos.y + 1:                            angle = 6
	CASE 5: npos.x = npos.x - 1: npos.y = npos.y + 1:       angle = 0
	CASE 6: npos.x = npos.x - 1:                            angle = 7
	CASE 7: npos.x = npos.x - 1: npos.y = npos.y - 1:       angle = 1

END SELECT

END SUB

SUB NewMap

CLS

'When drawing grid OffSet this much from top left corner:
os = 0
PRINT "Grid Size (Min=5/Max=80, Default 10)"
INPUT g
IF g = 0 THEN g = 10
IF g < 5 THEN g = 5
IF g > 80 THEN g = 80
PRINT "Horizontal size (X) Min: 3 Max:"; INT(640 / g)
INPUT xsize
IF xsize * g > 640 OR xsize = 0 THEN xsize = 640 / g
IF xsize < 3 THEN xsize = 3
PRINT "Vertical size (Y) Min: 3 Max:"; INT(460 / g)
INPUT ysize
IF ysize * g > 300 OR ysize = 0 THEN ysize = 460 / g
IF ysize < 3 THEN ysize = 3

REDIM map(xsize, ysize)
 FOR n = 1 TO xsize
  FOR m = 1 TO ysize
   map(n, m) = 1
    IF (n = 1 OR m = 1 OR n = xsize OR m = ysize) THEN map(n, m) = 0    'add border at map edges (0=wall,1=clear)
NEXT m: NEXT n

'place default start & destination lcations
xsta = 2: ysta = 2: xdes = xsize - 1: ydes = ysize - 1

END SUB

SUB Pathfind
mouse 0
Goalreached = 0
los = (g / 2) * -1
REDIM lenmap(xsize, ysize)
FOR n = 0 TO xsize
FOR m = 0 TO ysize
lenmap(n, m) = 32767
NEXT: NEXT

LOCATE 30, 1
FOR m = 1 TO 67: PRINT " "; :
NEXT

PCnt = 1
cpos.x = xsta
cpos.y = ysta
plist(0) = cpos
diffx = ABS(xsta - xdes): diffy = ABS(ysta - ydes)
IF wide = 1 THEN llist(0) = diffx + diffy ELSE llist(0) = (diffx * diffx) + (diffy * diffy)
lenmap(cpos.x, cpos.y) = 0



begin:
	'Find the one with lowest cost
	shortest = 0
	FOR n = 0 TO PCnt - 1
	IF llist(n) < llist(shortest) THEN shortest = n
	NEXT

cpos = plist(shortest)
plist(shortest) = plist(PCnt - 1)
llist(shortest) = llist(PCnt - 1)
PCnt = PCnt - 1

angle = 0: npos.y = npos.y - 1
FOR n = 0 TO 7
npos = cpos
CALL NewAngle
'Check if theres a free square here
IF lenmap(npos.x, npos.y) = 32767 AND map(npos.x, npos.y) > 0 THEN
stepcnt = lenmap(cpos.x, cpos.y) + map(npos.x, npos.y)
lenmap(npos.x, npos.y) = stepcnt
plist(PCnt) = npos
diffx = (npos.x - xdes)
diffy = (npos.y - ydes)
IF wide = 1 THEN llist(PCnt) = ABS(diffx) + ABS(diffy) + stepcnt ELSE llist(PCnt) = (diffx * diffx) + (diffy * diffy) + stepcnt

PCnt = PCnt + 1
LINE ((cpos.x * g) + los, (cpos.y * g) + los)-((npos.x * g) + los, (npos.y * g) + los), 7
END IF

IF (npos.x = xdes AND npos.y = ydes) THEN
Goalreached = 1
n = 8
GOTO endpath
END IF
NEXT
IF PCnt = 0 THEN GOTO endpath
GOTO begin


endpath:
IF Goalreached = 0 THEN
LOCATE 30, 1: PRINT "No Path Found!";
endloop:
i$ = INKEY$: IF i$ = "" THEN GOTO endloop
IF i$ = CHR$(27) THEN END
END IF

END SUB

SUB ReadData

'Reads machine language thingy MS.Data...

RESTORE MS.Data
 DEF SEG = VARSEG(ml(0))

 FOR i = 0 TO 99
  READ Octet$
  IF Octet$ = "#" THEN EXIT FOR
  POKE VARPTR(ml(0)) + i, VAL("&H" + Octet$)
 NEXT i

END SUB

SUB SaveMap

OPEN "pathfind.dat" FOR OUTPUT AS #1

 WRITE #1, g, xsize, ysize
  FOR n = 1 TO xsize
  FOR m = 1 TO ysize
   WRITE #1, map(n, m)
  NEXT: NEXT
 WRITE #1, xsta, ysta, xdes, ydes

CLOSE #1
END SUB

